//Fortran: EQUIVALENCE ( ... )
Unit AMZ1C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure AMZ1C(var A :Array of Complex; N :Integer;
                var B :Array of Complex);

implementation

procedure AMZ1C(var A :Array of Complex; N :Integer;
                var B :Array of Complex);
var
I1,J,JP1,K,I :Integer;
W :Complex;
T :Array [0..1] of Real;
label
_5,_10,_15,_20,_25;
begin
I1  := (N*(N+1)) div 2;
J  := N;
_5:
JP1  := J+1;
for K:=1 to J do
 begin
  I  := JP1-K;
  B[(I-1)+(J-1)*N] := Conjg(A[I1-1]);
  I1  := I1-1;
_10:
 end;
W  := B[(J-1)+(J-1)*N];
T[0] := W.re;  //  EQUIVALENCE
T[1] := W.im;  //  EQUIVALENCE 
B[(J-1)+(J-1)*N] := Cmplx(T[0],0.0);
J  := J-1;
if ( J  >=  1 ) 
 then goto _5;
if ( N  <  2 ) 
 then goto _25;
for I:=2 to N do
 begin
  I1  := I-1;
  for J:=1 to I1 do
   begin
    B[(I-1)+(J-1)*N] := Conjg(B[(J-1)+(I-1)*N]);
_15:
   end;
_20:
 end;
_25:
end;

end.
